﻿Imports System.Security.Cryptography
Imports System.Security.Cryptography.Pkcs
Imports System.Security.Cryptography.X509Certificates
Imports Syncfusion.Pdf.Parsing
Imports Syncfusion.Pdf.Security
Public Class PdfAssinar
    Public Function Assinar(sFicheiro As String, sDestino As String) As Boolean
        Dim document As PdfLoadedDocument = New PdfLoadedDocument(sFicheiro)
        'Creates a digital signature 
        Dim signature As PdfSignature = New PdfSignature(document, document.Pages(0), Nothing, "DigitalSignature")
        AddHandler signature.ComputeHash, AddressOf Signature_ComputeHash
        'Save the PDF document
        document.Save(sDestino)
        'Close the document
        document.Close(True)
    End Function

    Private Sub Signature_ComputeHash(ByVal sender As Object, ByVal arguments As PdfSignatureEventArgs)
        'Get the document bytes
        Dim documentBytes As Byte() = arguments.Data
        Dim signedCms As SignedCms = New SignedCms(New ContentInfo(documentBytes), detached:=True)
        'Compute the signature using the specified digital ID file and the password
        Dim certificate As X509Certificate2 = New X509Certificate2("DigitalSignatureTest.pfx", "DigitalPass123")
        Dim cmsSigner = New CmsSigner(certificate)
        'Set the digest algorithm SHA256
        cmsSigner.DigestAlgorithm = New Oid("2.16.840.1.101.3.4.2.1")
        signedCms.ComputeSignature(cmsSigner)
        'Embed the encoded digital signature to the PDF document
        arguments.SignedData = signedCms.Encode()
    End Sub
End Class
